﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;
using Infragistics.Win;

namespace WinTreeTriStateCheckBoxColumn
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraTree1.ViewStyle = ViewStyle.OutlookExpress;
        
            //Define a ColumnSet that represents the common column schema
            UltraTreeColumnSet commonColumnSet = new UltraTreeColumnSet();

            //Add columns to the ColumnSet
            commonColumnSet.Columns.Add("Column");
            commonColumnSet.Columns.Add("MyBoolColumn");

            commonColumnSet.Columns["MyBoolColumn"].DataType = typeof(string);

            CheckEditor checkEditor = new CheckEditor();
            checkEditor.ThreeState = true;

            commonColumnSet.Columns["MyBoolColumn"].AllowCellEdit = AllowCellEdit.Full;
            commonColumnSet.Columns["MyBoolColumn"].Editor = checkEditor;

            commonColumnSet.Columns["MyBoolColumn"].Editor.DataFilter = new CheckEditorDataFilter();

            this.ultraTree1.ColumnSettings.RootColumnSet = commonColumnSet;

            ////Define a Node that holds the first parent table and add it to the WinTree
            commonColumnSet.Columns["MyBoolColumn"].AllowCellEdit = AllowCellEdit.Full;
             ultraTree1.Override.CellClickAction = Infragistics.Win.UltraWinTree.CellClickAction.EditCell;

             for (int i = 0; i < 5; i++)
             {
                 UltraTreeNode node = ultraTree1.Nodes.Add(i.ToString(), i.ToString());
                 node.Override.ColumnSet = commonColumnSet;
                 node.Cells["Column"].Value = i;
                 node.Cells["MyBoolColumn"].Value = CheckState.Indeterminate;
              
             }
            ultraTree1.ExpandAll();
        }

        private void ultraTree1_InitializeDataNode(object sender, Infragistics.Win.UltraWinTree.InitializeDataNodeEventArgs e)
        {
           
        }
    }

    class CheckEditorDataFilter : Infragistics.Win.IEditorDataFilter
    {
        object Infragistics.Win.IEditorDataFilter.Convert(Infragistics.Win.EditorDataFilterConvertArgs args)
        {
            switch (args.Direction)
            {
                case ConversionDirection.EditorToOwner:
                    args.Handled = true;
                    CheckState state = (CheckState)args.Value;
                    switch (state)
                    {
                        case CheckState.Checked:
                            return "YES";
                        case CheckState.Unchecked:
                            return "NO";
                        case CheckState.Indeterminate:
                            return String.Empty;
                    }
                    break;
                case ConversionDirection.OwnerToEditor:
                    args.Handled = true;
                    if (args.Value.ToString() == "YES")
                        return CheckState.Checked;
                    else if (args.Value.ToString() == "NO")
                        return CheckState.Unchecked;
                    else
                        return CheckState.Indeterminate;
            }
            throw new Exception("Invalid value passed into CheckEditorDataFilter.Convert()");
        }
    }
}
